/*
    *
    * This file is a part of CoreAction.
    * A side bar for showing widgets for CuboCore Application Suite
    * Copyright 2019 CuboCore Group
    *

    *
    * This program is free software; you can redistribute it and/or modify
    * it under the terms of the GNU General Public License as published by
    * the Free Software Foundation; either version 3 of the License, or
    * (at your option) any later version.
    *

    *
    * This program is distributed in the hope that it will be useful,
    * but WITHOUT ANY WARRANTY; without even the implied warranty of
    * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    * GNU General Public License for more details.
    *

    *
    * You should have received a copy of the GNU General Public License
    * along with this program; if not, vsit http://www.gnu.org/licenses/.
    *
*/

#pragma once

#include <QDialog>
#include <QProcess>

#include <cprime/cplugininterface.h>

QT_BEGIN_NAMESPACE
namespace Ui {
    class ffsendIt;
}
QT_END_NAMESPACE

class ffsendIt : public QDialog {
    Q_OBJECT

public:
    ffsendIt(QStringList files, QWidget *parent = nullptr);
    ~ffsendIt();

    void sendFiles(QStringList files);

private slots:
    void on_doRename_clicked(bool checked);
    void on_upload_clicked();
    void on_copyURL_clicked();
    void on_copyImage_clicked();
    void on_saveImage_clicked();

    void on_close_clicked();

private:
    Ui::ffsendIt *ui;
    QProcess *proc;

    QStringList m_urls;

    bool checkffsend();
    void initialize();

    void procStateChanged(QProcess::ProcessState state);
    void procFinished(int exitCode, QProcess::ExitStatus status);

    QImage getQRImage(const QByteArray &termOutput);
};

class ffsendItPlugin : public ShareItInterface {
    Q_OBJECT

    Q_PLUGIN_METADATA(IID CPRIME_PLUGININTERFACE)
    Q_INTERFACES(ShareItInterface)

public:
    /* Name of the plugin */
    QString name();

    /* The plugin version */
    QIcon icon();

    /* MimeTypes handled by the plugin */
    QStringList mimeTypes();

    /* Context of the plugin */
    int context();

    /* The Widget */
    bool shareItDialog(QStringList files, QWidget *parent);
};
